/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.msp.role.GSetRoleBattleInfo
 *  fire.pb.GsClient
 *  fire.pb.PropConf$Battle
 *  fire.pb.battle.BattleEndHandler
 *  fire.pb.battle.BattleField
 *  fire.pb.battle.SRemoveWatcher
 *  fire.pb.battle.SSendBattleEnd
 *  fire.pb.team.PQuitTeamProc
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  gnet.link.Onlines
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.BattleInfo
 *  xtable.Battle
 *  xtable.Locks
 *  xtable.Watcherid2battleid
 */
package fire.pb.battle.watch;

import fire.msp.role.GSetRoleBattleInfo;
import fire.pb.GsClient;
import fire.pb.PropConf;
import fire.pb.battle.BattleEndHandler;
import fire.pb.battle.BattleField;
import fire.pb.battle.SRemoveWatcher;
import fire.pb.battle.SSendBattleEnd;
import fire.pb.team.PQuitTeamProc;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import gnet.link.Onlines;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.BattleInfo;
import xtable.Battle;
import xtable.Locks;
import xtable.Watcherid2battleid;

public class PEndWatchBattle
extends Procedure {
    private final long watcherid;
    private boolean isTeam;

    public PEndWatchBattle(long watcherid) {
        this.watcherid = watcherid;
        this.isTeam = false;
    }

    protected boolean process() throws Exception {
        Long battleid = Watcherid2battleid.select((Long)this.watcherid);
        if (battleid == null) {
            return false;
        }
        BattleInfo battle = Battle.get((Long)battleid);
        if (battle == null) {
            if (BattleField.logger.isDebugEnabled()) {
                BattleField.logger.debug((Object)("Can't find battleid by watcherid:" + this.watcherid));
            }
            return false;
        }
        Team watcherTeam = TeamManager.getTeamByRoleId((long)this.watcherid);
        if (watcherTeam != null) {
            if (watcherTeam.isNormalMember(this.watcherid)) {
                return true;
            }
            if (watcherTeam.isTeamLeader(this.watcherid)) {
                this.isTeam = true;
            }
        }
        if (this.isTeam && watcherTeam != null) {
            Iterator iterator = watcherTeam.getNormalMemberIds().iterator();
            while (iterator.hasNext()) {
                long normalTeamMemberid = (Long)iterator.next();
                this.removewatcher(battle, normalTeamMemberid);
            }
        } else {
            boolean ok = this.removewatcher(battle, this.watcherid);
            if (ok) {
                if (battle.getQuitteamroleids().contains(this.watcherid)) {
                    PEndWatchBattle.pexecuteWhileCommit((Procedure)new PQuitTeamProc(this.watcherid));
                }
                if (watcherTeam != null && watcherTeam.isReturnMember(this.watcherid)) {
                    watcherTeam.setTeamMemberStateWithSP(this.watcherid, 2);
                }
            }
            return ok;
        }
        return true;
    }

    private boolean removewatcher(BattleInfo battle, long watcherid) {
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, (Object[])new Object[]{watcherid}));
        Map audiences = battle.getAudience();
        int battleindex = 0;
        if (!audiences.containsKey(watcherid)) {
            return false;
        }
        battleindex = (Integer)audiences.get(watcherid);
        audiences.remove(watcherid);
        battle.getWatchers().remove(battleindex);
        Watcherid2battleid.remove((Long)watcherid);
        SSendBattleEnd snd = new SSendBattleEnd();
        Onlines.getInstance().send(Long.valueOf(watcherid), (Protocol)snd);
        if (battleindex < 31 + PropConf.Battle.WATCHERS_IN_BATTLE) {
            SRemoveWatcher srw = new SRemoveWatcher();
            srw.fighterindex = battleindex;
            Set allFightersID = battle.getRoleids().keySet();
            HashSet receiverSet = new HashSet();
            receiverSet.addAll(allFightersID);
            if (audiences.size() >= 1) {
                receiverSet.addAll(audiences.keySet());
            }
            Onlines.getInstance().send(receiverSet, (Protocol)srw);
        }
        GsClient.pSendWhileCommit((Protocol)new GSetRoleBattleInfo(watcherid, 0));
        for (BattleEndHandler handler : battle.getBattleendhandlers()) {
            handler.handleWatcherOutBattle(watcherid);
        }
        return true;
    }
}

